﻿using System;
using System.Windows.Forms;
using System.Diagnostics;

using Screentaker.Helper;

namespace Screentaker
{
    public partial class FormAbout : Form
    {
        #region Constructor
        
        public FormAbout()
        {
            InitializeComponent();
        }
        #endregion

        #region Internals

        public bool ShowInCorner = true;

        #endregion

        /// <summary>
        /// Schließt dieses Fenster
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        /// <summary>
        /// Öffnet die GPL.txt
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void linkLabelOpenGPL_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            using (Process _NewProcess = new Process())
            {
                _NewProcess.StartInfo.FileName = "http://www.gnu.de/documents/gpl.de.html";
                _NewProcess.Start();
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void FormAbout_Load(object sender, EventArgs e)
        {
            if (ShowInCorner == true)
            {
                
                this.Left = Screen.PrimaryScreen.WorkingArea.Width - this.Width;
                this.Top = Screen.PrimaryScreen.WorkingArea.Height - this.Height;
            }

            STSystem.AnimateWindow(this);

            labelVersion.Text = "Version: " + STSystem.AppVersion + " " + STSystem.AppVersionAd;
        }

        /// <summary>
        /// Mail an Christian
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void linkLabelMailDon_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            Process.Start("mailto:c.kratky@freenet.de");
        }

        /// <summary>
        /// Mail an Witold
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void linkLabelMailWiti_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            Process.Start("mailto:Witi83@web.de");
        }

        /// <summary>
        /// Öffnen der Homepage
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void linkLabelHomepage_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            Process.Start("http://www.winfuture-forum.de/index.php?showtopic=77047");
        }

        /// <summary>
        /// Auf Update prüfen
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonUpdate_Click(object sender, EventArgs e)
        {
            STSystem.ShowUpdate(this, true);
        }

        /// <summary>
        /// Ermöglicht eine Spende für das Tool
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonSpende_Click(object sender, EventArgs e)
        {
            STSystem.ProcessHelpRequest(Helper.STSystem.HelpRequestIDs.donate);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void FormAbout_FormClosing(object sender, FormClosingEventArgs e)
        {
            this.Dispose();
            GC.SuppressFinalize(this);
        }
    }
}